
#load'C:\Users\Keith\Documents\ShopProjects\TestPlugins\KK_BoxJointTool.rb'

  #portions of this code are modifications of examples from Google
  # Copyright 2005-2007, Google, Inc.
  # V2.0
  # Name :          KK_BoxJointTool  ###
  # Date :	        7 8 2011
  # Description :   Will draw BoxJoint Fingers in 2 Components for a Box Joint. 
  #                 Select Edge in First Component Parallel to Pattern
  #                 Select Second Edge 90 deg to first edge(Must have 1 Vertex Commom with First Edge)
  #                 Has the ability to work in mm & inches 
  #                 Will make a fingers in 1 component only
  #                 
                    
  # Author :        Keith Krueger (with a big help from plugin forum:)
  #
 
 require 'sketchup.rb'
  
class KK_BoxJointTool #*****************************************************************
  #Notes:
  #@status =1 select components =2 edge in second component, =3 first edge first component, =4 second edge first component
  #Selection problem handler ops, 0 ok,  1 not point/comp/edge, 2 edge1 not valid, 3 edge2 not valid
  
   @@fingerWidth=nil   #make class variables persist
   @@fingerLength=nil
   @@startFeature=nil
     
  def initialize
    @entity=nil
    @ss=nil
    @status=1
    @inpt=nil
    @tinpt=nil
    @ip=nil
    @component=1
    @first_comp=nil
    @second_comp=nil
    @tform=nil
    @tform2=nil
    @pt=Array.new 4
    @ptg=Array.new 4
    @ptC2=Array.new 4
    
    #defaults data for input forms
    if !@@fingerWidth then @@fingerWidth=0.250.inch end           
    if !@@fingerLength then @@fingerLength=0.75.inch end
    if !@@startFeature then @@startFeature="Finger" end

  end #def initialize

  #is called when first activated
  def activate
    @inpt = Sketchup::InputPoint.new           #set up Input point and temp and diplayed
    @tinpt= Sketchup::InputPoint.new
    @ip= Sketchup::InputPoint.new
    #lets clear any componenent that is already selected
    model=Sketchup.active_model
    entities = model.entities
    view = Sketchup.active_model.active_view
    @ss=model.selection
    le=@ss.count
    @statusstring= "Select First Component"
    Sketchup::set_status_text @statusstring,SB_PROMPT
    if le>=1 then @ss.clear end #Clear Selection
    self.reset(nil)   
  end #def activate
  
  #is called if tool is deactivated because a different tool is selected
  def deactivate(view)
    view.invalidate 
  end #def deactivate
  
  def resume(view)
    view.invalidate
    #@statusstring= "Select First Component"
    Sketchup::set_status_text @statusstring,SB_PROMPT
  end #def resume

  #onCancel is called when user hits escape etc
  def onCancel(reason, view)
    #Debug 
    UI.messagebox("Cancel, reason = " + reason.to_s)
    view.invalidate
    @oops=0
    @ss.clear
    @component=1
    @first_comp=nil
    @second_comp=nil
    @status=1
    if @first_comp!=nil then @first_comp.hidden=false end
    if @second_comp!=nil then @second_comp.hidden=false end
    @statusstring= "Select First Component"
    Sketchup::set_status_text @statusstring,SB_PROMPT
  end #def onCancel

  #reset to start over again
  def reset(view)
    @status=1
    @displayed=false
    @entity=nil
    @statusstring= "Select First Component"
    Sketchup::set_status_text @statusstring,SB_PROMPT
  end #def reset
  
#Translate a string to a float value, accepting mathematical forumal in the string - return nil of invalid
  def equationString(s)
    #Debug UI.messagebox("testNo = " + s)
	  return nil unless s
	  s = s.strip.upcase
	  lform = ["PI", "sin", "cos", "tan", "atan2", "sqrt", "log", "log10", "exp", "ceil", "floor", "round"]
	  lform.each_with_index { |f, i| s = s.gsub(f.upcase, "_#{i}_") }
	  s = s.gsub(/,\d/) { |c| '.' + c[1..1] }
	  return nil if s =~ /[^\s\+\-\*\.\,eE_\%\/\%\(\)\d]/
	  s = s.gsub(/(\A\.)\d+/) { |ss| '0' + ss }
	  s = s.gsub(/(\s|\(|\+|\-)(\.)(\d+)/) { |ss| $1 + '0.' + $3 }
	  s = s.gsub(',', '.').gsub(/(\d+)\.*(\d*)(e|E)?(\d*)/) { |ss| (ss =~ /\.|e|E/) ? ss : ss + '.0' }
	  s = s.gsub(/_(\d+)\.\d_/) { |f| "Math::#{lform[$1.to_i]}" }
	  s = s.gsub(/\s+\(/, '(')	
	  begin 
		  eval "0.0 + (#{s})"
	    rescue Exception => detail
		  nil
	  end	# begin
  end #def equationString

  def inputData_Box_Joint    
    fw_input=@@fingerWidth.to_s
    
    prompts = ["Finger Width","Starting Feature"]

    defaults= [fw_input,@@startFeature]
               
    choices = ["","Finger|Space"]
   
    results = inputbox prompts, defaults, choices, "Input Data for Finger Joint"
                                                    
    if not results  # user cancel                  
      @oops=0
      @ss.clear
      @component=1   
      @status=1
      if @first_comp!=nil then @first_comp.hidden=false end
      if @second_comp!=nil then @second_comp.hidden=false end
      @first_comp=nil
      @second_comp=nil
      @statusstring= "Select Firstxx Component"
      Sketchup::set_status_text @statusstring,SB_PROMPT
		elsif #not results
		
    fw_input=equationString(results[0])
    if fw_input== nil then fw_input=results[0] end
    @@fingerWidth=fw_input.to_l #Make sure its a Length no & displays Units
       		
		@@startFeature=results[1]
		end #not results
  end #inputData_Box_Joint
  
def inputData_Box_Fingers    
    fw_input=@@fingerWidth.to_s
    fl_input=@@fingerLength.to_s
    
    prompts = ["Finger Width","Starting Feature","Finger Length"]

    defaults= [fw_input,@@startFeature,fl_input]
               
    choices = ["","Finger|Space",""]
   
    results = inputbox prompts, defaults, choices, "Input Data for Finger Joint"
                                                    
    if not results  # user cancel                  
      @oops=0
      @ss.clear
      @component=1   
      @status=1
      if @first_comp!=nil then @first_comp.hidden=false end
      if @second_comp!=nil then @second_comp.hidden=false end
      @first_comp=nil
      @second_comp=nil
      @statusstring= "Select First Component"
      Sketchup::set_status_text @statusstring,SB_PROMPT
		end #not results
		
    fw_input=equationString(results[0])
    if fw_input== nil then fw_input=results[0] end
    @@fingerWidth=fw_input.to_l #Make sure its a Length no & displays Units       
		
		@@startFeature=results[1]
		
    fl_input=equationString(results[2])
    if fl_input== nil then fl_input=results[2] end
    @@fingerLength=fl_input.to_l #Make sure its a Length no & displays Units
       
  end #inputData_Box_Fingers  
     
  def round_3places(n)  
    n=(n*1000).to_i
    UI.messagebox("n = " + n.to_s)
    n=n.to_f/1000      
  end #def round_3places
          
  def points_Fingers(x,y,z,fw,t,dir_y)
    @pt[0]=Geom::Point3d.new(x,y*dir_y,z)
    @pt[1]=Geom::Point3d.new(x,(y+t)*dir_y,z)
    @pt[2]=Geom::Point3d.new(x+fw,(y+t)*dir_y,z)
    @pt[3]=Geom::Point3d.new(x+fw,y*dir_y,z)  
    #Debug @pt.each {|e| UI.messagebox("point = "+ e.to_s)}    
  end #points_DominoMortise_Comp1
  
  #cruise for a point in component
  def onMouseMove(flags, x, y, view)
    if (@status==2 or @status==3 or @status==4)
      @tinpt.pick view, x, y
      if (@tinpt.valid?) 
        changed=@tinpt != @inpt
        @inpt.copy! @tinpt 
        view.tooltip = @tinpt.tooltip
        #display point
        if ( changed and (@inpt.display? or @displayed))
          view.invalidate 
        end #if ( changed
      end # if (@tinpt.valid?
    end  #if (@status==
  end #def onMouseMove

#get a point
  def onLButtonDown(flags, x, y, view)
    #Debug UI.messagebox("On Button Down with status = " + @status.to_s)
    if @status==1  #select component
      @oops=1
      ph=view.pick_helper
      ph.do_pick x,y
      @entity=ph.best_picked
      if @entity
        type=@entity.typename
        if type=="ComponentInstance"
          @oops=0
          @ss.add(@entity)
          if@@tooltype=="Box_Joint" 
            if @component==1
              @first_comp=@entity
              @component=2
              @statusstring= "Select Second component"
              Sketchup::set_status_text @statusstring,SB_PROMPT
            elsif @component==2
              @second_comp=@entity
              @statusstring= "Select any Edge in Component2 "
              Sketchup::set_status_text @statusstring,SB_PROMPT
              @status=2            
            end #@component==1
          else #if@@tooltype=="Box_Joint"
            @first_comp=@entity
            @statusstring= "Select Edge in First Component Parallel to Pattern"
            Sketchup::set_status_text @statusstring,SB_PROMPT  
	          @status=3
          end  #if@@tooltype=="Box_Joint"
        else  # ComponentInstance
          UI.messagebox "Selection invalid"
        end  # ComponentInstance
      end #@entity      
    elsif @status==2  #select edge in Second Component
      @ip.pick view,x,y
	    @oops=2
      if(@ip.valid?)
	      if(@ip.edge)
	        if (@entity.definition==@ip.edge.parent)
	          if ((!@ip.vertex) and (@ip.depth>0))
		          @oops=0
		          @edge3=@ip.edge
		          codef=@entity.definition            
		          #This secton added to get point transformation
              @tform2 = @ip.transformation.inverse
              @ss.clear
              @entity=@first_comp
              @ss.add(@first_comp)
              @second_comp.hidden=true
              @first_comp.hidden=false
              @statusstring= "Select Edge in First Component Parallel to Pattern"
              Sketchup::set_status_text @statusstring,SB_PROMPT  
	            @status=3
		        end #@ip.vertex
	        end	#@entity.definition
	      end #@ip.edge
	    end #@ip.valid?                                 
    elsif @status==3 #select first edge in component 1
	    @ip.pick view,x,y
	    @oops=3
      if(@ip.valid?)
	      if(@ip.edge)
	        if (@entity.definition==@ip.edge.parent)
	          if ((!@ip.vertex) and (@ip.depth>0))
		          @oops=0
		          @edge1=@ip.edge
              @edge1_L=@edge1.length		          
		          #This secton added to get point transformation
              @tform = @ip.transformation
              #Debug UI.messagebox("@tform = " + @tform.to_s)              
              @statusstring= "Select Second Edge 90 deg to first edge(Must have 1 Vertex Commom with First Edge)"
              Sketchup::set_status_text @statusstring,SB_PROMPT 
	            #Sketchup::set_status_text "Select Second Edge 90 deg to first edge(Must have 1 Vertex Commom with First Edge)",SB_PROMPT
              @status=4
		        end #@ip.vertex
	        end	#@entity.definition
	      end #@ip.edge
	    end #@ip.valid?	    	   	    	    	    
	  elsif @status==4 #select second edge in component 1
      @ip.pick view,x,y
	    @oops=4
      if(@ip.valid?)&& (@ip.edge)
	      if(@ip.edge!=@edge1)&&((@e1sp==@e2sp) || (@e1sp==@e2ep)|| (@e1ep==@e2sp) || (@e1ep==@e2ep))
	        if (@entity.definition==@ip.edge.parent)
	          @oops=0
            @edge2=@ip.edge
            @edge2_L=@edge2.length
            @e1sp=@edge1.start.position
			      @e1ep=@edge1.end.position
			      #Debug UI.messagebox("@e1sp = " + @e1sp.to_s)
			      #Debug UI.messagebox("@e1ep = " + @e1ep.to_s)
	          @e2sp=@edge2.start.position
			      @e2ep=@edge2.end.position
	          if ((@e1sp==@e2sp) || (@e1sp==@e2ep))
              orig=@e1sp
              p1=@e1sp
              p2=@e1ep
            end #if ((@e1sp==
            if ((@e1ep==@e2sp) || (@e1ep==@e2ep))
              orig=@e1ep
              p2=@e1sp
              p1=@e1ep
            end  #if ((@e1ep==
            if orig==@e2sp
              p3=@e2ep
            else
              p3=@e2sp
            end #if orig
            
            #Debug Check points UI.messagebox("p1 = " + p1.to_s)         
			      #Debug UI.messagebox("p2  = " + p2.to_s)       
            #Debug UI.messagebox("p3 = " + p3 .to_s)             
            #Debug UI.messagebox("orig  = " + orig .to_s)
                        
            #collect entities
            componentdefinition=@entity.definition
            allent=componentdefinition.entities
            codef=@entity.definition
            #collect face entities
            faceent=[]
            allent.each do |ent|
              if ent.typename=="Face" 
                faceent << ent
              end #if ent.typename==
            end #allent.each do              
	          #find face that has edges 1 and 2
		    	  face=@edge1.common_face @edge2
		    	  if (face==nil)#14                    #get valid face
		          @oops=4
            else 
              #Debug UI.messagebox"got valid face"
              #get points in local coord system for face
			        #xaxis parallel to @edge1
              x,y,z=face.normal.axes
			        #get vector parallel to @edge1              			         			          
			        ar=[p2.x-p1.x,p2.y-p1.y,p2.z-p1.z]
			        xx=ar.normalize
		          yy=z.cross xx
              localt=Geom::Transformation.axes(orig,xx,yy,z).invert!
			        backt=Geom::Transformation.axes(orig,xx,yy,z)
			        edges=face.outer_loop.edges
			        eind=edges.index(@edge1)
			        e_len=@edge1.length
			        #Points on face in local coordinates
			        p1=p1.transform(localt)
			        p2=p2.transform(localt)
			        p3=p3.transform(localt)           
 			        x1=p1.x
			        x2=p2.x
			        y1=p1.y
			        y2=p3.y
              if x1>x2 then dir_x = -1 end
			        if x1<x2 then dir_x = +1 end
			        if y1<y2 then dir_y = +1 end
			        if y1>y2 then dir_y = -1 end
            			                      
              #Get User Input Data
              if @@tooltype == "Box_Joint"
                inputData_Box_Joint
                @@fingerLength=@edge2_L
              elsif @@tooltype == "Box_Fingers"
                inputData_Box_Fingers               
              end # if @@tooltype == "Box_Joint"
              
              #Set Loop Starting Variables
              xsp = 0.00 #Starting point for x
              i = "even"
              if @@startFeature == "Space" then i="odd"  end
              #UI.messagebox("Program Ok to Here 1")
              n=@edge1_L
              n1=17  #safety valve
              #START LOOP
              Sketchup.active_model.start_operation "Fingers" 
              #UI.messagebox("Program Ok to Here ")               
              while n > 0               			          
    			        
                #Calculate points for Slot Face
                points_Fingers(xsp,0,0,@@fingerWidth,@edge2_L,dir_y)                
                #Debug UI.messagebox"Returned from Calculating Points for Mortise Face "
                
                #Transform Mortise Face Points to Component 1 Coordinates
                @pt=@pt.collect {|point| point.transform(backt)}
                            
                #Add Finger Face
                if @@tooltype=="Box_Joint" then @second_comp.hidden=false  end
	              #@first_comp.hidden=false
                @entity=@first_comp
                codef=@entity.definition
                @ss.clear
                @ss.add(@first_comp)
                #UI.messagebox("Program Ok to Here 3")
                if i=="odd"
                  cface=codef.entities.add_face(@pt) #Fixed array so it uses all elements!
                  #Debug  @pt.each {|element| UI.messagebox("@pt point comp 1 = "+ element.to_s)}
                  cface.pushpull(-1*@@fingerLength)
                  #Feature added to First component at this point
                end # if i=="odd"
                if @@tooltype=="Box_Joint"
                  @entity=@second_comp
                  codef=@entity.definition
                  @ss.clear
                  @ss.add(@second_comp)
                  @statusstring= "Adding Feature to Second Component"
                  Sketchup::set_status_text @statusstring,SB_PROMPT                            	            
	                @ptg=@pt.collect {|point| point.transform(@tform)}
	                
	                @ptC2=@ptg.collect {|point| point.transform(@tform2)}
	                if i=="even"            
	                  cface=codef.entities.add_face(@ptC2)
                    cface.pushpull(-1*@@fingerLength)
                  end # if i=="even"
                  #Feature added to second component at this point
                end #if @@tooltype=="Box_Joint"
                #Reset Loop Variables
                case i
                  when "odd"
                    i="even" 
                  when "even"
                    i="odd" 
                end #case i
                #UI.messagebox("i = " + i.to_s )
                xsp=xsp+@@fingerWidth                
                n=@edge1_L-xsp
                #Debug UI.messagebox("n Left = " + n.to_s )
                #n1=n1-1
                #if n1<=0 then n=0 end #Safety Valve
              end #while n > 0
              Sketchup.active_model.commit_operation
              @statusstring= "Feature Added to Second Component"
              Sketchup::set_status_text @statusstring,SB_PROMPT
              #END LOOP
                                                        
              @status=0
              @statusstring="Domino Joint/Mortises Complete;  "
              Sketchup::set_status_text @statusstring,SB_PROMPT
              result=UI.messagebox "Domino Mortise Complete; Start New Joint? ", MB_YESNO
              if result==7 then Sketchup.send_action("selectSelectionTool:") end
              if result==6 then onCancel(result, view) end              
 		        end #face==nil                        
	        end	#@entity.definition
	      end #@ip.edge
	    end #@ip.valid?
    end #if @status==?
	  #Debug UI.messagebox("End if & elsif status;  status = " + @status.to_s)
	  
	  #Selection problem handler @oops, 0 ok,  1 not comp, 2 edge3(any edge in C2) not valid, 3 edge1 not valid, 4 edge2 not valid
    case @oops
      when 1        
        @status=1
      when 2
        UI.messagebox "Edge Not Valid: Pick again"
        @edge3=nil
        @status=2
      when 3
        UI.messagebox "Edge Not Valid: Pick again"
        @edge1=nil
        @status=3 
      when 4
        UI.messagebox "Edge Not Valid: Pick again"
        @edge2=nil
        @status=4     
	  end # case @oops 
	  
	end #def onLButtonDown  
   
  #draw is called when we want to display then point
  def draw(view)
    if( @inpt.valid? and @inpt.display? )
      @inpt.draw view
      @displayed=true
    else
      @displayed=false
    end #@inpt.valid?
  end #def draw

  
end #end Class KK_BoxJointTool*********************************************

  #function acts as short cut for selecting tool
  def boxjointtool
    Sketchup.active_model.select_tool KK_BoxJointTool.new
    @@tooltype="Box_Joint"
  end #def dominojointtool
  
  def boxfingertool
    Sketchup.active_model.select_tool KK_BoxJointTool.new
    @@tooltype="Box_Fingers"
  end #def dominomortisetool
   
  #add to Draw menu after separator

  if( not file_loaded?("KK_BoxJointTool.rb"))
    # Access the main Draw menu
    draw_menu = UI.menu "Draw"
    # Add a separator and a submenu
    draw_menu.add_separator
    sub_menu = draw_menu.add_submenu("Box Joint")
    # Add two menu items to the submenu
    #it1 = sub_menu.add_item("Box_Joint") {boxjointtool}
    it2 = sub_menu.add_item("Box_Fingers") {boxfingertool}   
  end #not file_loaded?

  file_loaded("KK_BoxJointTool.rb")
  #--------------------------------------
